function krpulse, percentage,xsize,ysize
;creates a step mask as a function of percentage done

newMask = bytarr(xsize,ysize) + 255B ;start out opaque
pulseSize = 50
pulsePos = xsize * percentage
pulse = bytscl(reverse(findgen(pulseSize)))
if pulsePos lt pulseSize then begin
  length = pulseSize - pulsePos -1
  pulse = pulse[length:*]
  start = 0
endif else begin
  start = pulsePos - pulseSize
endelse
x = bytarr(xsize) + 255B
x[start] = pulse
y = bytarr(ysize)+1B
ramp =x#y
newMask[0,0] = ramp
return,newMask
end

;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro maskFunctionExample2
;shows how to make a pulse go across the screen

device,get_screen_size=scrSize
oProgress = obj_new('krProgressBar',xsize=200,ysize=25,xoffset=scrSize[0]/2, $
                     yoffset=scrSize[1]/2, /displayPercent, maskFunction='krpulse', $
                     tlb_frame_attr=4)

for i=1,100 do begin
  oProgress->upDate,i/100.
  wait,0.1
endfor

obj_destroy, oProgress

return & end