function krpulse, percentage,xsize,ysize
;creates a step mask as a function of percentage done

newMask = bytarr(xsize,ysize) + 255B ;start out opaque
pulseSize = 50
pulsePos = xsize * percentage
pulse = bytscl(reverse(findgen(pulseSize)))
if pulsePos lt pulseSize then begin
  length = pulseSize - pulsePos -1
  pulse = pulse[length:*]
  start = 0
endif else begin
  start = pulsePos - pulseSize
endelse
x = bytarr(xsize) + 255B
x[start] = pulse
y = bytarr(ysize)+1B
ramp =x#y
newMask[0,0] = ramp
return,newMask
end


;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro userImageObjectExample2

device,get_screen_size=scrSize

file = filepath('rose.jpg',subdir=['examples','data'])
read_jpeg,file,image
sz = size(image,/dimen)
oImage = obj_new('IDLgrImage',image)
oProgress = obj_new('krProgressBar',xsize=sz[1],ysize=sz[2],xoffset=scrSize[0]/2, $
                     yoffset=scrSize[1]/2, /displayPercent, backgroundImage=oImage, $
                     maskfunction='krpulse')

for i=0,100 do begin
  oProgress->upDate,i
  wait, 0.05
endfor

obj_destroy, oProgress

return & end