function krpulse, percentage,xsize,ysize
;creates a step mask as a function of percentage done

newMask = bytarr(xsize,ysize) + 255B ;start out opaque
pulseSize = 50
pulsePos = xsize * percentage
pulse = bytscl(reverse(findgen(pulseSize)))
if pulsePos lt pulseSize then begin
  length = pulseSize - pulsePos -1
  pulse = pulse[length:*]
  start = 0
endif else begin
  start = pulsePos - pulseSize
endelse
x = bytarr(xsize) + 255B
x[start] = pulse
y = bytarr(ysize)+1B
ramp =x#y
newMask[0,0] = ramp
return,newMask
end


;{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|{{:|

pro userImageObjectExample3
;uses mask and image object

device,get_screen_size=scrSize

image = bytarr(3,200,20) + 255B ;all white
;create a group of green blocks
;first create a small array of 0 and 1's
numblocks = 25 ;making the numblocks smaller gives bigger blocks
blocks = (bindgen(numblocks,1) mod 2)
;use congrid (and nearest neighbor) to expand this out
blocks = congrid(blocks,200)
;find out where we have 1's
indices = where(blocks eq 1)
image[0,indices,*] = 0B
image[1,indices,*] = 255B ;green
image[2,indices,*] = 0B
oImage = obj_new('IDLgrImage',image)
;now make a white mask
image[*,*,*] = 255B
oMask = obj_new('IDLgrImage',image)
oProgress = obj_new('krProgressBar',xsize=200,ysize=20,xoffset=scrSize[0]/2, $
                     yoffset=scrSize[1]/2, /displayPercent, backgroundImage=oImage, $
                     maskImage=oMask, maskfunction='krpulse', message='', $
                     textColor=[0,0,0])

for i=0,100 do begin
  oProgress->upDate,i
  wait,0.05
endfor

obj_destroy, oProgress

return & end